﻿using System;
using System.Drawing;
using System.IO;
using System.Threading;
using System.Windows.Forms;

namespace QR_Encoder1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        
        Int16[,] QR_Daten = new Int16[13, 162];
        string[] QR_DatenREM = new string[13];
        int QR_Daten_Position = -1;

        // Farben     wenn    R + G + B < 200 .... schwarz
        Color schwarz = Color.FromArgb(0, 0, 0);
        Color weiss = Color.FromArgb(255, 255, 255);
        Color randlinie = Color.FromArgb(200, 200, 200);
        Color patternweiss = Color.FromArgb(255, 200, 200);
        Color patternweiss1 = Color.FromArgb(200, 255, 200);
        Color uebrigweiss = Color.FromArgb(255, 255, 100);
        Color patternschwarz = Color.FromArgb(0, 0, 150);     // schwarz

        Bitmap piCBild; 

        int version, ECL, maske, kästchenzahl, kantenlänge, rand,
            ZeichenModus,        // 1  ... numerisch,   2 ... alphanumerisch,    3 ... byte,   
            KorrekturModus,      // 0 .. L,   1 .. M,   2 .. Q,   3 .. H
            korrBytesProBlock, anzBlockGr1, anzBlockGr2, datenBytesProGr1Block, datenBytesProGr2Block;


        int[,] feldFarbe, feldFarbeOhneMaske;
        int[,] bitArt;  // sp , ze    ....  0 bis 5  ...  0:Datenbits;  1: ECC-Bits;   2:Finder/Alignments;  3:Timer;  4:Dark module;  5:Formatbereich
        Bitmap Bild, Bild1, Bild2;
        string bitfolge;

        int zaehlwerk;

        Bitmap TestBild = new Bitmap(300, 300);

        // Ende globale Variable ----------------------------------------------------------------------------


        // Anfang mit Spielerei -----------------------------------------------------------------------------
        private void button1_Click_1(object sender, EventArgs e) // Test ... male Gesicht
        {
            pB_test.Image = TestBild;
            Graphics g = Graphics.FromImage(pB_test.Image);

            Color S = Color.Black;
            Color W = Color.White;
            Color F = S;
            for (int i = 0; i < 15; i++)
                for (int j = 0; j < 15; j++) g.FillRectangle(new SolidBrush(W), (0 + i) * 20, (0 + j) * 20, 20, 20);
            maleFinderTest(g, 0, 0); maleFinderTest(g, 10, 0); maleFinderTest(g, 0, 10);
            maleKästchen(g, S, 8, 7); maleKästchen(g, S, 12, 7);  // Augen
            maleKästchen(g, S, 10, 9); maleKästchen(g, S, 10, 10);  // Nase
            for (int i = 9; i < 12; i++) maleKästchen(g, S, i, 12);  // Mund
            Bitmap piCBild = (Bitmap)pB_test.Image;
            Rectangle cloneRect = new Rectangle(0, 0, piCBild.Width, piCBild.Height);
            System.Drawing.Imaging.PixelFormat format = piCBild.PixelFormat;
            TestBild = piCBild.Clone(cloneRect, format);

        }

        private void button1_Click(object sender, EventArgs e) // Testbild mit Gesicht ...  mit Maske 0
        {
            pB_test.Image = TestBild;
            Graphics g = Graphics.FromImage(pB_test.Image);
            Color S = Color.Black;
            Color W = Color.White;
            Color F;
            for (int i = 0; i < 15; i++)
                for (int j = 0; j < 15; j++)
                    if ( ! (
                             ((i < 5) && (j < 5)) || 
                             ((j > 9) && (i < 5)) || 
                             ((j < 5) && (i > 9))
                            )
                        )
                    {
                        Color I = TestBild.GetPixel(i * 20, j * 20);
                        F = I;
                        if ((i + j) % 2 == 0) if (I.R + I.G + I.B < 300) F = W; else F = S;
                        g.FillRectangle(new SolidBrush(F), i * 20, j * 20, 20, 20);
                    }
            TestBild = (Bitmap)pB_test.Image;
        }

        private void maleKästchen(Graphics g, Color R, int sp, int ze)  // im Testbild
        {
            g.FillRectangle(new SolidBrush(R), sp * 20, ze * 20, 20, 20);
        }

        private void maleFinderTest(Graphics g, int sp, int ze)  // im Testbild
        {
            Color S = Color.Black;
            Color W = Color.White;
            int i = 0, j = 0;
            for (i = 0; i < 5; i++)
                for (j = 0; j < 5; j++) g.FillRectangle(new SolidBrush(S), (sp+i) * 20, (ze+j) * 20, 20, 20);
            for (i = 1; i < 4; i++)
                for (j = 1; j < 4; j++)
                    if ((i!=2) || (j!=2)) g.FillRectangle(new SolidBrush(W), (sp + i) * 20, (ze + j) * 20, 20, 20);
        }


        private void pB_test_MouseDown(object sender, MouseEventArgs e)  // im Testbild
        {
            
        }

        // Ende mit Spielerei -----------------------------------------------------------------------------



        private int textlänge()
        {
            string s = rTB_Text.Text;
            int anzDB = s.Length;

            return anzDB;
        }

        private void rtbo(RichTextBox r, string s)  // in RichTextBox ... oben anfügen
        {
            r.Text = s + r.Text;
        }

        private void radioButtonClick()
        {
            Zeichen_Version(textlänge());
        }

        private string bitsAusInt(int a) // Bits aus einer Integerzahl bilden
        {
            string bits = Convert.ToString(a, 2);
            if (bits.Length < 8) bits = "00000000".Substring(0, 8 - bits.Length) + bits;
            return bits;
        }

        private string bitsAusIntL(int a, int L)  // Bits bilden ... Bitfolge mit Länge L ; ggf. vorn mit "0" füllen
        {
            string bits = Convert.ToString(a, 2);
            string s = new string('0', L - bits.Length);
            bits = s + bits;
            return bits;
        }


        private int[] getAlignmentCoords(int version) // Alignment-Mitte-Koordinaten ermitteln
        {
            if (version <= 1) { return new int[0]; }
            int anz = (version / 7) + 2; // Anzahl der Werte im Ergebnisfeld
            int[] ergebnis = new int[anz];
            ergebnis[0] = 6;

            // für Version > 1
            ergebnis[anz - 1] = 4 * version + 10;
            if (anz == 2) { return ergebnis; } // version 2 ... 6

            // nur für Version >= 7
            ergebnis[anz - 2] = 2 * ((ergebnis[0] + ergebnis[anz - 1] * (anz - 2)) / ((anz - 1) * 2));
            /*                         nicht kürzen!!! INT-Divisionen
                                      
                einziger Fehler bei Version 32:    anz=6; e[0]=6; e[5]=138;  
                  e[4]=2*[ (6+138*4)/(5*2) ] = 2 *[558/10] = 2*55 = 110;     !!     112 wäre richtig
            */ 
            if (version == 32) ergebnis[anz - 2] = 112;
            if (anz == 3) { return ergebnis; } // version 7 ... 13

            // nur für Version >= 14
            int schrittweite = ergebnis[anz - 1] - ergebnis[anz - 2];
            for (int i = anz - 3; i > 0; i--) ergebnis[i] = ergebnis[i + 1] - schrittweite;
            return ergebnis;
        }

        private void maleBitRand(Graphics g, Color R, int sp, int ze) // Randfarbe R
        {
            g.DrawRectangle(new Pen(R),
                 rand * kantenlänge + sp * kantenlänge + 1, rand * kantenlänge + ze * kantenlänge + 1,
                 kantenlänge - 1, kantenlänge - 1);
        }

        private void fülleBit(Graphics g, Color F, Color R, int sp, int ze) // Füllfarbe F, Randfarbe R
        {
            g.FillRectangle(new SolidBrush(F),
                 rand * kantenlänge + sp * kantenlänge + 1, rand * kantenlänge + ze * kantenlänge + 1,
                 kantenlänge - 1, kantenlänge - 1);
            maleBitRand(g, R, sp, ze);
            if ((F.R + F.G + F.B) < 350) feldFarbe[sp, ze] = 1; else feldFarbe[sp, ze] = 0;
        }

        private void speichereB1_Click(object sender, EventArgs e) // Zwischenspeicher 1 eines Bildes
        {
            Rectangle cloneRect = new Rectangle(0, 0, piCBild.Width, piCBild.Height);
            System.Drawing.Imaging.PixelFormat format = piCBild.PixelFormat;
            Bild1 = piCBild.Clone(cloneRect, format);
        }

        private void speichereB2_Click(object sender, EventArgs e) // Zwischenspeicher 2 eines Bildes
        {
            Rectangle cloneRect = new Rectangle(0, 0, piCBild.Width, piCBild.Height);
            System.Drawing.Imaging.PixelFormat format = piCBild.PixelFormat;
            Bild2 = piCBild.Clone(cloneRect, format);
        }



        private void ladeB1_Click(object sender, EventArgs e) // Bild aus dem Zwischenspeicher 1 holen
        {
            if (Bild1 != null)
            {
                Rectangle cloneRect = new Rectangle(0, 0, Bild1.Width, Bild1.Height);
                System.Drawing.Imaging.PixelFormat format = Bild1.PixelFormat;
                Bild = Bild1.Clone(cloneRect, format);
                piCBild = Bild;
                picB_QRC.Image = piCBild;
            }
        }



        private void ladeB2_Click(object sender, EventArgs e) // Bild aus dem Zwischenspeicher 2 holen
        {
            if (Bild1 != null)
            {
                Rectangle cloneRect = new Rectangle(0, 0, Bild2.Width, Bild2.Height);
                System.Drawing.Imaging.PixelFormat format = Bild2.PixelFormat;
                Bild = Bild2.Clone(cloneRect, format);
                piCBild = Bild;
                picB_QRC.Image = piCBild;
            }
        }

        private void but_FarbKorr_Click(object sender, EventArgs e) // farbige Kästchen in schwaarz / weiß umfärben
        {
            but_FarbKorr.BackColor = Color.Coral;
            Color F;
            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);

            for (int i = 0; i < kästchenzahl; i++)  // Zeile
                for (int j = 0; j < kästchenzahl; j++) // Spalte
                {
                    {
                        if (feldFarbe[j, i] == 0) { F = weiss; } else { F = schwarz; }
                        fülleBit(g, F, F, j, i);
                    }
                }
            piCBild = (Bitmap)picB_QRC.Image;
        }



        private void Laden()  //  Start des Programms -----------------------
        {
            StreamReader r = new StreamReader("QR_Daten.txt"); // Einlesen der Vorgabedaten
            int i = 0;
            while (!r.EndOfStream)
            {
                string s = r.ReadLine();
                string[] h = s.Split(';');

                if (h.Length >= 160)
                {
                    QR_DatenREM[i] = h[0];
                    for (int j = 1; j <= 160; j++)
                    {
                        if (h[j] == "") h[j] = "0";
                        try { QR_Daten[i, j] = Convert.ToInt16(h[j]); }
                        catch { QR_Daten[i, j] = -1; rTB_Info.AppendText("\nFehler bei " + h[0] + ", " + j.ToString()); }
                    }
                    rTB_Info.AppendText("\n" + h[0].PadLeft(25) + ":  ");
                    for (int j = 1; j <= 160; j++) rTB_Info.AppendText(h[j].PadLeft(5) + " ");
                }
                i++;
            }
            r.Close();

            rTB_Info.AppendText("\n");

            ZeichenModus = 3;                                          // byte
            if (rB_modeNum.Checked == true) { ZeichenModus = 1; }      // numerisch
            if (rB_modeAlphanum.Checked == true) { ZeichenModus = 2; } // alphanumerisch

            KorrekturModus = 0;              // Error Correction  auf L .... "interne" Zahlen dafür
            if (rB_ECC_M.Checked == true) { KorrekturModus = 1; }  // M
            if (rB_ECC_Q.Checked == true) { KorrekturModus = 2; }  // Q
            if (rB_ECC_H.Checked == true) { KorrekturModus = 3; }  // H


        }


        private void Zeichen_Version(int tl) // Die Version aus der Zeichenzahl und em Korrekturmodus ermitteln
        {
            tB_Ver1.Text = tl.ToString();  // Zeichenzahl im Text
            int ver = -1;
            for (int i = 1 + KorrekturModus * 40; i <= 40 + KorrekturModus * 40; i++)
                if (QR_Daten[ZeichenModus + 1, i] >= tl)
                {
                    ver = QR_Daten[0, i];
                    QR_Daten_Position = i;
                    tB_Ver3.Text = QR_Daten[5, QR_Daten_Position].ToString();  // Datenbytes insgesamt

                    korrBytesProBlock = QR_Daten[8, QR_Daten_Position];   // Korrekturbytes pro Block
                    tB_Ver4.Text = korrBytesProBlock.ToString();

                    anzBlockGr1 = QR_Daten[9, QR_Daten_Position];  // Blocks in Gr. 1
                    tB_Ver5.Text = anzBlockGr1.ToString();
                    anzBlockGr2 = QR_Daten[11, QR_Daten_Position]; // Blocks in Gr. 2
                    tB_Ver6.Text = anzBlockGr2.ToString();

                    datenBytesProGr1Block = QR_Daten[10, QR_Daten_Position]; // Datenbytes je Blocks in Gr. 1
                    tB_Ver7.Text = datenBytesProGr1Block.ToString();
                    datenBytesProGr2Block = QR_Daten[12, QR_Daten_Position]; // Datenbytes je Blocks in Gr. 2
                    tB_Ver8.Text = datenBytesProGr2Block.ToString();

                    tB_Ver9.Text = QR_Daten[7, QR_Daten_Position].ToString();  // Summe Blöcke

                    tB_Ver10.Text = QR_Daten[ZeichenModus + 1, QR_Daten_Position].ToString();  // max. ZeichenZahl


                    i = 1000;
                }

            if (ver >= 1)
            {
                tB_Ver2.Text = ver.ToString(); // Version
            }
        }

        private void but_Erstellung_Enter(object sender, EventArgs e)
        {
            EC_Mode();
            Zeichen_Version(textlänge());
        }

        private void but_ohneMaske_Click(object sender, EventArgs e)
        {
            but_Maske.BackColor = Color.LightGreen;
            but_FarbKorr.BackColor = Color.LightGreen;

            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);
            Color F;
            for (int i = 0; i < feldFarbe.GetLength(0); i++)
                for (int j = 0; j < feldFarbe.GetLength(1); j++)
                {
                    if (bitArt[i, j] == 0)
                    {
                        feldFarbe[i, j] = feldFarbeOhneMaske[i, j];

                        if (feldFarbe[i, j] == 0) // also weiss
                        { F = weiss; }
                        else { F = schwarz; }

                        if (bitArt[i, j] == 0) fülleBit(g, F, F, i, j);
                    }
                }
            piCBild = (Bitmap)picB_QRC.Image;
            maske = -1;
        }

        private void but_zB_Num_Click(object sender, EventArgs e)
        {
            rTB_Text.Text = "23571113171923293137414347515359";
            rB_modeNum.Checked = true;
        }

        private void but_zB_AlphaNum_Click(object sender, EventArgs e)
        {
            rTB_Text.Text = "ALPHANUMERISCHER MODE: DAS IST EIN TEST MIT ALPHANUMERISCHEN ZEICHEN - UMLAUTE SIND NICHT ERLAUBT - ZAHLEN 01234... SCHON ... UND  .:$%/*+-";
            rB_modeAlphanum.Checked = true;
        }

        private void but_zB_Byte_Click(object sender, EventArgs e)
        {
            rTB_Text.Text = "BYTE-Mode: Hier sind fast alle Zeichen erlaubt und man kann normalen Text schreiben. " +
                "Auch alle Sonderzeichen wie @ und / und \\ sind im Zeichensatz möglich. ";
            rB_modeByte.Checked = true;
        }

        private void picB_QRC_MouseDown(object sender, MouseEventArgs e)
        {
            int sp = e.X;
            int ze = e.Y;
            int r = 20;
            try { r = Convert.ToInt16(tB_Verunreinigung.Text); } catch { r = 20; tB_Verunreinigung.Text = "20"; }
            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);
            if ((sp-r>=0) && (sp+r<piCBild.Width) && (ze-r>=0) && (ze + r < piCBild.Height))
                 g.FillEllipse(new SolidBrush(Color.Black), sp - r, ze - r, 2*r, 2*r);

            piCBild = (Bitmap)picB_QRC.Image;
        }

        private int bestimmeGuete(bool anzeigen)
        {
            int score = 0;
            int teilscore = 0;
            string h = "";
            string[] farbenFeldHorizontal = new string[kästchenzahl];
            string[] farbenFeldVertikal = new string[kästchenzahl];
            for (int i = 0; i < kästchenzahl; i++)  // alle Zeilen nacheinander
            {
                h = "";
                for (int j = 0; j < kästchenzahl; j++) h = h + feldFarbe[j, i].ToString();
                farbenFeldHorizontal[i] = h;
                h = "";
                for (int j = 0; j < kästchenzahl; j++) h = h + feldFarbe[i, j].ToString();
                farbenFeldVertikal[i] = h;
            }


            if (anzeigen) tabControl1.SelectedTab = tabControl1.TabPages[2];

            if (anzeigen) if (maske>=0) rTB_Guete.AppendText("\n\n" + kästchenzahl.ToString() + " Kästchen pro Zeile/Spalte  .... Maskennummer: " + maske.ToString() + "\n");
            else rTB_Guete.AppendText("\n\n" + kästchenzahl.ToString() + " Kästchen pro Zeile/Spalte ...  ! unmaskiert !\n");
            /*
            The four penalty rules can be summarized as follows:

            The first rule gives the QR code a penalty for each group of five or more same-colored modules in a row (or column).
            The second rule gives the QR code a penalty for each 2x2 area of same-colored modules in the matrix.
            The third rule gives the QR code a large penalty if there are patterns that look similar to the finder patterns.
            The fourth rule gives the QR code a penalty if more than half of the modules are dark or light, with a larger penalty for a larger difference.
            */
            /* Penalty 1 */
            if (anzeigen) rTB_Guete.AppendText("Penalty 1:\n");
            for (int auswahl = 1; auswahl <= 2; auswahl++)
            {
                teilscore = 0;
                for (int i = 0; i < kästchenzahl; i++)  // alle Zeilen nacheinander
                {
                    if (auswahl == 1) h = farbenFeldHorizontal[i]; else h = farbenFeldVertikal[i];

                    //bool ok = true;
                    int k = 0, pos = 0, ort = 0; ;
                    while ((h.IndexOf("00000") >= 0) || (h.IndexOf("11111") >= 0))
                    {
                        int pos1 = 1000, pos2 = 1000;
                        if (h.IndexOf("00000") >= 0) pos1 = h.IndexOf("00000");
                        if (h.IndexOf("11111") >= 0) pos2 = h.IndexOf("11111");
                        pos = Math.Min(pos1, pos2);
                        ort = ort + pos;
                        char c = h[pos];
                        teilscore = teilscore + 3;
                        //if (anzeigen) rTB_Guete.AppendText("     " + c + " : " + ort.ToString() + " ");
                        k = 5;
                        bool ok1 = true;
                        if (pos + k < h.Length)
                        {
                            while (ok1)
                            {
                                if (h[pos + k] == c)
                                {
                                    teilscore++;
                                    k++;  //if (anzeigen) rTB_Guete.AppendText("  " + (ort + k).ToString()+" + ");
                                    if (pos + k >= h.Length) ok1 = false;
                                }
                                else ok1 = false; ;
                            }
                        }
                        if (pos + k < kästchenzahl - 1) { h = h.Substring(pos + k); ort = ort + k; }
                        else h = "---";
                        if (h.Length < 5) { h = "-------"; }

                    }
                    //if (anzeigen) rTB_Guete.AppendText("  " + i.ToString() + "  " + teilscore.ToString() + "\n");
                }
                score = score + teilscore;
                if (anzeigen) rTB_Guete.AppendText("   Penalty 1:   " + auswahl.ToString() + ":   TeilScore Penalty 1: " + teilscore.ToString() + "      total:  " + score.ToString() + "\n");

            }

            // Ende Penalty 1

            /* Penalty 2 */
            if (anzeigen) rTB_Guete.AppendText("Penalty 2:\n");
            teilscore = 0;
            for (int i = 0; i < kästchenzahl - 1; i++)  // alle Zeilen nacheinander
            {
                for (int j = 0; j < kästchenzahl - 1; j++)
                {
                    int f1 = feldFarbe[j, i];
                    if ((feldFarbe[j + 1, i] == f1) &&
                        (feldFarbe[j, i + 1] == f1) &&
                        (feldFarbe[j + 1, i + 1] == f1)) teilscore = teilscore + 3;
                }
            }
            score = score + teilscore;
            if (anzeigen) rTB_Guete.AppendText("   Penalty 2:    TeilScore: " + teilscore.ToString() + "      total:  " + score.ToString() + "\n");

            // Ende Penalty 2

            /* Penalty 3 */
            teilscore = 0;
            if (anzeigen) rTB_Guete.AppendText("Penalty 3:\n");
            for (int auswahl = 1; auswahl <= 2; auswahl++)
            {
                for (int i = 0; i < kästchenzahl; i++)  // alle Zeilen/Spalten nacheinander
                {
                    if (auswahl == 1) h = farbenFeldHorizontal[i]; else h = farbenFeldVertikal[i];

                    //if (anzeigen) rTB_Guete.AppendText(i.ToString().PadLeft(3) + ": " + h + "\n");
                    int pos = 0, ort = 0; ;
                    while ((h.IndexOf("00001011101") >= 0) || (h.IndexOf("10111010000") >= 0))
                    {
                        int pos1 = 1000, pos2 = 1000;
                        if (h.IndexOf("00001011101") >= 0) pos1 = h.IndexOf("00001011101");
                        if (h.IndexOf("10111010000") >= 0) pos2 = h.IndexOf("10111010000");
                        pos = Math.Min(pos1, pos2);
                        ort = ort + pos;
                        if (anzeigen) rTB_Guete.AppendText("    " + auswahl.ToString() + ":  " + i.ToString().PadLeft(3) + ": " + ort.ToString() + "\n");
                        char c = h[pos];
                        teilscore = teilscore + 40;
                        if (pos + 4 < kästchenzahl - 1) { h = h.Substring(pos + 4); ort = ort + 4; }
                        else h = "---";
                        if (h.Length < 11) { h = "-------------------"; }

                    }
                    //if (anzeigen) rTB_Guete.AppendText("  " + i.ToString() + "  " + teilscore.ToString() + "\n");
                }
                score = score + teilscore;
                if (anzeigen) rTB_Guete.AppendText("   Penalty 3:   " + auswahl.ToString() + ":   TeilScore Penalty 1: " + teilscore.ToString() + "      total:  " + score.ToString() + "\n");
            }
            // Ende Penalty 3

            /* Penalty 4 */
            if (anzeigen) rTB_Guete.AppendText("Penalty 4:\n");
            teilscore = 0;
            int schwarzFeld = 0;
            for (int i = 0; i < kästchenzahl; i++)  // alle Zeilen nacheinander
                for (int j = 0; j < kästchenzahl; j++)
                    if (feldFarbe[j, i] == 1) schwarzFeld++;
            double prozentwertSchwarz = 100 * (schwarzFeld * 1.0) / (kästchenzahl * kästchenzahl);
            if (anzeigen) rTB_Guete.AppendText("   Anteil schwarze Felder: " + prozentwertSchwarz.ToString("#0.0") + "%\n");

            int faktor = (int)(Math.Abs(50 - prozentwertSchwarz) / 5);
            teilscore = 10 * faktor;

            score = score + teilscore;
            if (anzeigen) rTB_Guete.AppendText("   Penalty 4:    TeilScore: " + teilscore.ToString() + "      total:  " + score.ToString() + "\n");

            // Ende Penalty 4


            return score;
        }


        private void but_guete_Click(object sender, EventArgs e)
        {
            tB_Penalty.Text = bestimmeGuete(true).ToString();
        }

        private void nud_Maske_ValueChanged(object sender, EventArgs e)
        {
            but_Maske.BackColor = Color.LightGreen;
            tB_Penalty.Text = "";
        }

        private void rTB_Text_TextChanged(object sender, EventArgs e)
        {
            Zeichen_Version(textlänge());

            if (but_Erstellung.BackColor == Color.Coral)
            {
                but_Erstellung.BackColor = Color.LightGreen;
                but_Formatangaben.BackColor = Color.LightGreen;
                but_EC.BackColor = Color.LightGreen;
                but_Maske.BackColor = Color.LightGreen;
                but_FarbKorr.BackColor = Color.LightGreen;
            }
        }

        private void but_maskenTest_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabControl1.TabPages[3];
            rTB_BestGuete.Clear();

            int gueteMin = 50000, bmNr=-1;
            for (int m=7;m>=0;m--)
            {
                maskeAnwenden(m);
                int guete = bestimmeGuete(false);
                rtbo(rTB_BestGuete, "Maske " + m.ToString()+  " ... Güte " + guete.ToString()+"\n");
                if (guete < gueteMin)
                {
                    gueteMin = guete;
                    
                    bmNr = m;
                }
            }
            rtbo(rTB_BestGuete, "Bestmaskennummer ist " + bmNr.ToString()+"\n\n");
            if ((int)nud_Maske.Value != bmNr) nud_Maske.Value = bmNr;
            tB_Penalty.Text = "";
        }

        private void but_B1_Click(object sender, EventArgs e) // Byte  L   Version 1
        {
            rTB_Text.Text = "Die Blume blüht";
            rB_modeByte.Checked = true;
            rB_ECC_L.Checked = true;

            
        }

        private void but_B2_Click(object sender, EventArgs e)  // Byte  Q   Version 31
        {
            rTB_Text.Text = "Die ersten Olympischen Spiele in Olympia wurden der Überlieferung zufolge im antiken Griechenland "+
                "im Jahr 776 v. Chr. abgehalten. Mit diesem Jahr beginnen die Siegerlisten. Es ist der Ausgangspunkt der klassischen"+
                "griechischen Zeitrechnung.[3] Die Zählung der Olympiaden wurde aber erst vom Geschichtsschreiber Timaios von "+
                "Tauromenion eingeführt, der im 4. und 3. Jahrhundert v. Chr. lebte. Erst danach begann die Datierung von Ereignissen"+
                " nach Olympiaden, und die Olympiadenrechnung wurde zur Grundlage der griechischen Chronologie."+
                "Neuzeit\n"+
                "1896 begann die erste Olympiade der Neuzeit in Athen.Das Internationale Olympische Komitee definiert die Olympiade "+
                "als den Zeitraum von vier Jahren, der jeweils am 1.Januar des Jahres der Sommerspiele beginnt.[2] Die erste "+
                "Olympiade der Neuzeit begann demnach am 1.Januar 1896, die XXXI. Olympiade der Neuzeit am 1.Januar 2016, im Jahr "+
                "der Olympischen Sommerspiele 2016, die deshalb offiziell die Spiele(zur Feier) der XXXI. Olympiade heißen. ";

            rB_modeByte.Checked = true;
            rB_ECC_Q.Checked = true;
        }

        private void but_B3_Click(object sender, EventArgs e)
        {
            rTB_Text.Text = "DIE OLYMPISCHE IDEE WURDE IN GRIECHENLAND GEBOREN UND GERIET IM MITTELALTER BIS ANFANG DES 20. JAHRHUNDERTS IN VERGESSENHEIT";
            rB_modeAlphanum.Checked = true;
            rB_ECC_H.Checked = true;
        }

        private void but_B4_Click(object sender, EventArgs e)
        {
            rTB_Text.Text = "01234567891111111110123456789012345679012345678955555555501234567890123456790"+
                            "12345678901234567901234567899999999990123456789222222222012345678901234567901234567890123456791953";
            rB_modeNum.Checked = true;
            rB_ECC_M.Checked = true;
        }


        private void but_Demo_Click(object sender, EventArgs e)  // Kästchenränder zeichnen
        {
            Color F;
            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);
            Color S = Color.Black;
            for (int i = 0; i < kästchenzahl; i++)  // Zeile
                for (int j = 0; j < kästchenzahl; j++) // Spalte
                {
                    if (bitArt[j, i] == 0)
                    {
                        if (feldFarbe[j, i] == 0) { F = weiss; } else { F = schwarz; }
                        fülleBit(g, F, S, j, i);
                    }
                }
            piCBild = (Bitmap)picB_QRC.Image;
        }

        private void but_Ende_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void EC_Mode()
        {
            
            ZeichenModus = 3;                                   // Mode indicator für byte
            if (rB_modeNum.Checked == true) {  ZeichenModus = 1; }      // für numerisch
            if (rB_modeAlphanum.Checked == true) {  ZeichenModus = 2; } // für alphanumerisch

            KorrekturModus = 0; ECL = 1;    // Error Correction Level  auf L
            if (rB_ECC_M.Checked == true) { KorrekturModus = 1; ECL = 0; }// M
            if (rB_ECC_Q.Checked == true) { KorrekturModus = 2; ECL = 3; }// Q
            if (rB_ECC_H.Checked == true) { KorrekturModus = 3; ECL = 2; }// H
        }

        private void panel1_MouseLeave(object sender, EventArgs e)
        {
            EC_Mode();
            Zeichen_Version(textlänge());
        }

        private void pan_ECC_MouseLeave(object sender, EventArgs e)
        {

            EC_Mode();
            Zeichen_Version(textlänge());
        }

        private void radioButtonClick(object sender, EventArgs e)
        {
            EC_Mode();
            Zeichen_Version(textlänge());

            but_Erstellung.BackColor = Color.LightGreen;
            but_Formatangaben.BackColor = Color.LightGreen;
            but_EC.BackColor = Color.LightGreen;
            but_Maske.BackColor = Color.LightGreen;
            but_FarbKorr.BackColor = Color.LightGreen;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Laden();
            
        }

        private void maskeAnwenden(int maskenNummer) // nur feldFarbe ändern!!!! 
        {
            // unmaskierten Stand holen
            for (int i = 0; i < feldFarbe.GetLength(0); i++)
                for (int j = 0; j < feldFarbe.GetLength(1); j++)
                    if (bitArt[j, i] == 0) feldFarbe[i, j] = feldFarbeOhneMaske[i, j];

            

            for (int i = 0; i < kästchenzahl; i++)  // Zeile
                for (int j = 0; j < kästchenzahl; j++) // Spalte
                    if (bitArt[j, i] == 0)
                    {
                        bool ok = false;
                        switch (maskenNummer)
                        {
                            case 0:
                                if ((i + j) % 2 == 0) ok = true;
                                break;
                            case 1:
                                if (i % 2 == 0) ok = true;
                                break;
                            case 2:
                                if (j % 3 == 0) ok = true;
                                break;
                            case 3:
                                if ((i + j) % 3 == 0) ok = true;
                                break;
                            case 4:
                                if (((i / 2) + (j / 3)) % 2 == 0) ok = true;
                                break;
                            case 5:
                                if (((i * j) % 2) + ((i * j) % 3) == 0) ok = true;
                                break;
                            case 6:
                                if ((((i * j) % 2) + ((i * j) % 3)) % 2 == 0) ok = true;
                                break;
                            case 7:
                                if ((((i + j) % 2) + ((i * j) % 3)) % 2 == 0) ok = true;
                                break;

                            default:

                                break;
                        }

                        if (ok == true)
                        {
                            if (feldFarbe[j, i] == 0) { feldFarbe[j, i] = 1; }  // also weiss
                            else {  feldFarbe[j, i] = 0; }
                        }
                    }
        }


        private void but_Maske_Click(object sender, EventArgs e)
        {
            but_Maske.BackColor = Color.Coral;
            but_FarbKorr.BackColor = Color.LightGreen;

            maske = (int)nud_Maske.Value;
            but_Formatangaben_Click(sender, e);

            maskeAnwenden(maske);

            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);
            // feldFarbe übertragen in das Bild:
            Color F;
            for (int i=0;i<kästchenzahl;i++)  // Zeile
                for (int j=0;j<kästchenzahl;j++) // Spalte
                    if (bitArt[j, i] == 0)
                    { 
                        if (feldFarbe[j, i] == 0) { F = weiss; }  
                        else { F = schwarz;  }

                        fülleBit(g, F, F, j, i);
                    }

            piCBild = (Bitmap)picB_QRC.Image;
            tB_Penalty.Text = "";
        }



        private void maleFinder(Graphics g, int spLO, int zeLO)
        {
            // zuerst: Löschen des Bereiches:
            for (int sp = spLO - 1; sp < spLO + 8; sp++)
                for (int ze = zeLO - 1; ze < zeLO + 8; ze++)
                {
                    if ((sp >= 0) && (sp < kästchenzahl) && (ze >= 0) && (ze < kästchenzahl))
                    {
                        fülleBit(g, patternweiss, randlinie, sp, ze);
                        bitArt[sp, ze] = 2;
                    }
                }

            for (int sp = spLO + 0; sp < spLO + 7; sp++)
            {
                fülleBit(g, schwarz, randlinie,  sp, zeLO + 0);
                fülleBit(g, schwarz, randlinie,  sp, zeLO + 6);
            }
            for (int sp = spLO + 2; sp < spLO + 5; sp++)
                for (int ze = zeLO + 2; ze < zeLO + 5; ze++)
                    fülleBit(g, schwarz, randlinie,  sp, ze);
            for (int ze = zeLO + 0; ze < zeLO + 7; ze++)
            {
                fülleBit(g, schwarz, randlinie,  spLO + 0, ze);
                fülleBit(g, schwarz, randlinie,  spLO + 6, ze);
            }
        }

        private void maleAlignment(Graphics g, int aS, int aZ)
        {
            // zuerst: Löschen des Bereiches:
            for (int sp = aS-2; sp <= aS+2; sp++)
                for (int ze = aZ-2; ze <= aZ+2; ze++)
                {
                    if ((sp >= 0) && (sp < kästchenzahl) && (ze >= 0) && (ze < kästchenzahl))
                    {
                        fülleBit(g, patternweiss, randlinie, sp, ze);
                        bitArt[sp, ze] = 2;
                    }
                }

            Color F; int i1 = -1;
            i1 = aZ - 2; F = schwarz;
            for (int k = aS - 2; k <= aS + 2; k++) fülleBit(g, F, randlinie, k, i1);
            fülleBit(g, schwarz, randlinie, aS, aZ);
            i1 = aZ + 2; F = schwarz;
            for (int k = aS - 2; k <= aS + 2; k++) fülleBit(g, F, randlinie, k, i1);
            for (i1=aZ-1;i1<=aZ+1;i1++)
            {
                fülleBit(g, schwarz, randlinie, aS - 2, i1);
                fülleBit(g, schwarz, randlinie, aS + 2, i1);
            }
            
        }

        private string exklusivOder(string s, string t)
        {
            while (s.Length != t.Length)
            {
                if (s.Length > t.Length) t = "0" + t; else s = "0" + s;
            }
            string erg = "";
            for (int i = 0; i < s.Length; i++)
                if (s[i] == t[i]) erg = erg + "0"; else erg = erg + "1";
            while (erg[0] == '0') erg = erg.Substring(1);

            return erg;
        }




        //string formatBits = RS1(ECLBits + maskenBits, 15, "10100110111");
        private string RS1(string format, int gesamtlänge, string generator) // Kodierung von Format und Version
        {                                                                    // jeweils mit verschiedenen Generatoren
            string start = format;
            int noch = gesamtlänge - start.Length;
            while (start.Length < gesamtlänge) start = start + "0";

            if (start.IndexOf("1") >= 0)
            {
                while (start[0] == '0') start = start.Substring(1);
                kommentarBox.AppendText("\nBestimmung der DatenBits + ECC-Bits:\n");

                while (start.Length >= generator.Length)
                {
                    string gen = generator;
                    kommentarBox.AppendText("Start:         " + start.PadLeft(gesamtlänge) + "\n");

                    while (gen.Length < start.Length) gen = gen + "0";
                    kommentarBox.AppendText("    Generator: " + gen.PadLeft(gesamtlänge) + "\n");
                    string erg = "";
                    for (int i = 0; i < start.Length; i++)
                        if (start[i] == gen[i]) erg = erg + "0"; else erg = erg + "1";
                    while (erg[0] == '0') erg = erg.Substring(1);
                    start = erg;
                    kommentarBox.AppendText("    Ergebnis:  " + erg.PadLeft(gesamtlänge) + "\n");

                }
                while (start.Length < noch) start = "0" + start;
                start = format + start;
                return start;
            }
            else return start;
        }


        private void but_Erstellung_Click(object sender, EventArgs e)
        {
            but_Erstellung.BackColor = Color.Coral;
            but_Formatangaben.BackColor = Color.LightGreen;
            but_EC.BackColor = Color.LightGreen;
            but_Maske.BackColor = Color.LightGreen;
            but_FarbKorr.BackColor = Color.LightGreen;

            tB_Penalty.Text = "";

            piCBild = new Bitmap(picB_QRC.Width, picB_QRC.Height);
            Bild = new Bitmap(picB_QRC.Width, picB_QRC.Height);

            rTB_Info.Clear();
            kommentarBox.Clear();

            version = Convert.ToInt16(tB_Ver2.Text); 
            
            rand = 3;
            kästchenzahl = 17 + version * 4;
            bitArt = new int[kästchenzahl, kästchenzahl];
            feldFarbe = new int[kästchenzahl, kästchenzahl]; 

            kantenlänge = (int)nud_bitfeldKL.Value;
            while ((kästchenzahl + 2 * rand) * kantenlänge >= Math.Min(picB_QRC.Width, picB_QRC.Height)) kantenlänge--;

            nud_bitfeldKL.Value = kantenlänge;

            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);
            g.Clear(weiss);

            int sp = -1, ze = -1;
            
            // Finder with Separators:   
            maleFinder(g, 0, 0);
            maleFinder(g, kästchenzahl-7, 0);
            maleFinder(g, 0, kästchenzahl - 7);

            // Alignments
            int[] alignments = getAlignmentCoords(version);
            rTB_Alignment.Text = "Alignments:  Werte für das Mittenpixel\n   (Nummerierung ab Zeile 0, Spalte 0 - links oben)\n";
            
            for (int i = 0; i < alignments.Length; i++)
            {
                int aZ = alignments[i];
                rTB_Alignment.AppendText("\nZeile " + aZ.ToString().PadLeft(3) + ":  Spalten ");
                for (int j = 0; j < alignments.Length; j++)
                {
                    int aS = alignments[j];
                    if (  !(  ((aZ < 11) && (aS < 11)) ||                    // links oben im Finder
                              ((aZ > kästchenzahl - 11) && (aS < 11)) ||     // rechts oben im Finder
                              ((aZ < 11) && (aS > kästchenzahl - 11))        // links unten im Finder
                           )
                       )
                    {
                        rTB_Alignment.AppendText(aS.ToString().PadLeft(3) + " ");
                        maleAlignment(g, aS, aZ);
                    }
                }
            }

            // Timerlinien
            Color F;
            ze = 6; 
            for (sp=8;sp<kästchenzahl-8;sp++)
            {
                if (sp % 2 == 0) F = schwarz; else F = patternweiss;
                fülleBit(g, F, randlinie, sp, ze);
                fülleBit(g, F, randlinie, ze, sp);  // gespiegelt!
                bitArt[sp, ze] = 3;
                bitArt[ze, sp] = 3;
            }

            // Dark Module
            
            ze = kästchenzahl-8;
            sp = 8;
            {
                fülleBit(g, schwarz, randlinie, sp, ze);
                bitArt[sp, ze] = 4;
            }

            piCBild = (Bitmap)picB_QRC.Image;

        }



        private void but_Formatangaben_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabControl1.TabPages[1];
            int warteZeit = 0;
            kommentarBox.Clear();
            but_Formatangaben.BackColor = Color.DarkOrange;
            
            /*
            Error Correction Level,	Bits, Integer Equivalent
                L	                 01	      1
                M	                 00	      0
                Q 	                 11	      3
                H	                 10	      2  
            */

            ECL = 1;   // Error Correction Level  auf L
            if (rB_ECC_M.Checked == true) ECL = 0; // M
            if (rB_ECC_Q.Checked == true) ECL = 3; // Q
            if (rB_ECC_H.Checked == true) ECL = 2; // H

            maske = (int)nud_Maske.Value;


            // Error Correction Level  +   Maskennummer
            string ECLBits = Convert.ToString(ECL,2);
                 while (ECLBits.Length < 2) ECLBits = "0" + ECLBits;

            string maskenBits = Convert.ToString(maske, 2);
                 while (maskenBits.Length < 3) maskenBits = "0" + maskenBits;

            // REDD-SOLOMON für Formatbits
            

            kommentarBox.AppendText("Error Correction Level  " + ECLBits + "  und Maskenbits  " + maskenBits + "\n");
            kommentarBox.AppendText("Error Correction Level + Maskennummer  " + ECLBits + maskenBits + "\n");
            kommentarBox.AppendText("    Generatorpolynom x^10 + x^8 + x^5 + x^4 + x^2 + x + 1\n       ... kurz 10100110111\n");

            string formatBits = RS1(ECLBits + maskenBits,15, "10100110111"); 
                     // Generatorpolynom   x10 + x8 + x5 + x4 + x2 + x + 1
            formatBits = exklusivOder(formatBits, "101010000010010"); // XOR mit 101010000010010

            while (formatBits.Length < 15) formatBits = "0" + formatBits;
            kommentarBox.AppendText("\n  ----->  Format-Bits:    " + formatBits+"\n");

            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);

            for (int i = 0; i <= 6; i++)
            {
                Color F;
                if (formatBits[i] == '0') F = patternweiss1; else F = patternschwarz;  
                if (F == patternweiss1)  fülleBit(g, Color.FromArgb(F.R, F.G, F.B - 50), randlinie, 8, kästchenzahl - 1 - i);
                if (F == patternschwarz) fülleBit(g, Color.FromArgb(F.R, F.G, F.B + 50), randlinie, 8, kästchenzahl - 1 - i);
                bitArt[8, kästchenzahl - 1 - i] = 5;
                kommentarBox.AppendText("8," + (kästchenzahl - 1 - i).ToString() + " : " + 
                       feldFarbe[8, kästchenzahl - 1 - i].ToString() + "   ;    ");
                if (i < 6) { fülleBit(g, F, randlinie, i, 8); bitArt[i,8] = 5;
                    kommentarBox.AppendText(i.ToString() + ",8 : " + feldFarbe[i, 8].ToString()+"\n");
                }
                else
                {
                    fülleBit(g, F, randlinie, 7, 8);
                    bitArt[7, 8] = 5;
                    kommentarBox.AppendText("7,8 : " + feldFarbe[7, 8].ToString() + "\n");
                }
                Thread.Sleep(warteZeit);
                picB_QRC.Refresh();
            }

            for (int i = 7; i <= 14; i++)
            {
                Color F, F1;
                int pos = 14 - i;
                if (formatBits[i] == '0') F = patternweiss1; else F = patternschwarz;
                fülleBit(g, F, randlinie, kästchenzahl - pos -1, 8);
                bitArt[kästchenzahl - pos - 1, 8] = 5;
                kommentarBox.AppendText((kästchenzahl - pos - 1).ToString() + ",8 : " +
                       feldFarbe[kästchenzahl - pos - 1, 8].ToString() + "   ;    ");
                if (F == patternweiss1) F1 = Color.FromArgb(F.R, F.G, F.B - 50);
                else F1 = Color.FromArgb(F.R, F.G, F.B + 50);  // F;
                if (pos > 5) { fülleBit(g, F1, randlinie, 8, pos + 1); bitArt[8, pos + 1] = 5;
                    kommentarBox.AppendText("8," + (pos + 1).ToString() + " : " +
                       feldFarbe[8, pos + 1].ToString() + "\n");
                }
                else { fülleBit(g, F1, randlinie, 8, pos); bitArt[8, pos] = 5;
                    kommentarBox.AppendText("8," + (pos).ToString() + " : " +
                           feldFarbe[8, pos].ToString() + "\n");
                }
                
                Thread.Sleep(warteZeit);
                picB_QRC.Refresh();
            }
            /**/



            // Versionbereich ... bei Version >= 7
            if (version > 6)
            {

                tB_Ver2.BackColor = Color.DarkOrange;
                string versionS = Convert.ToString(version, 2);
                while (versionS.Length < 6) versionS = "0" + versionS;
                kommentarBox.AppendText("\nVersion:  " + versionS + "\n");
                kommentarBox.AppendText("   Generatorpolynom x^12 + x^11 + x^10 + x^9 + x^8 + x^5 + x^2 + 1\n      ... kurz 1111100100101\n");

                string versionBits = RS1(versionS, 18, "1111100100101"); 
                                 // Generatorpolynom   x12 + x11 + x10 + x9 + x8 + x5 + x2 + 1 

                while (versionBits.Length < 18) versionBits = "0" + versionBits;
                kommentarBox.AppendText("\n  ---->  Versions-Bits:  " + versionBits + "\n");
                /* Anordnung der VersionsBits rechts oben - links neben dem Finder, oben bündig
                                           18 17 16
                                           15 14 13
                                           12 11 10
                                            9  8  7
                                            6  5  4         
                                            3  2  1 

                links unten über dem Finder, links bündig  
                18 15 12  9  6  3
                17 14 11  8  5  2 
                16 13 10  7  4  1
                */

                int ze = 5, sp = kästchenzahl - 9, k = 3;
                for (int i = 0; i <= 17; i++)
                {
                    Color F;
                    if (versionBits[i] == '0') F = patternweiss1; else F = patternschwarz;
                    fülleBit(g, F, randlinie, sp, ze); bitArt[sp, ze] = 5;
                    fülleBit(g, F, randlinie, ze, sp); bitArt[ze, sp] = 5; // gespiegelt
                    k--;
                    sp--;
                    if (k == 0) { k = 3; sp = kästchenzahl - 9; ze--; }
                }
            }
            else tB_Ver2.BackColor = Color.Yellow;

            piCBild = (Bitmap)picB_QRC.Image;
            tB_Penalty.Text = "";
        }


        private void but_EC_Click(object sender, EventArgs e)
        {
            but_EC.BackColor = Color.Khaki;
            
            but_Maske.BackColor = Color.LightGreen;
            but_FarbKorr.BackColor = Color.LightGreen;

            tabControl1.SelectedTab = tabControl1.TabPages[0];
            Zeichen_Version(textlänge());

            // Mode indicator
            string Zeichenart = "Byte";
            string modeInd = "0100";                               // Mode indicator für byte
            if (rB_modeNum.Checked == true) { modeInd = "0001"; Zeichenart = "Numerisch"; }      // für numerisch
            if (rB_modeAlphanum.Checked == true) { modeInd = "0010"; Zeichenart = "Alphanumerisch"; } // für alphanumerisch

            bitfolge = modeInd; // Hier geht es los mit der Bitfolge
            string info = "Modus: " + Zeichenart + "\n";
            string showBitfolge = bitfolge;
            if (cB_Info.Checked==true) rTB_Info.AppendText("\nModus: " + Zeichenart + " --> Bitfolge\n" + bitfolge + "\n");
            // Character Count Indicator
            int charCountInd = 8;
            if (version < 10)
            {
                if (modeInd == "0001") charCountInd = 10;  // für numerisch
                if (modeInd == "0010") charCountInd = 9;   // für alphanumerisch
                if (modeInd == "0100") charCountInd = 8;   // Mode indicator für byte
            }
            if ((version >= 10) && (version <= 26))
            {
                if (modeInd == "0001") charCountInd = 12;
                if (modeInd == "0010") charCountInd = 11;
                if (modeInd == "0100") charCountInd = 16;
            }
            if (version > 26)
            {
                if (modeInd == "0001") charCountInd = 14;
                if (modeInd == "0010") charCountInd = 13;
                if (modeInd == "0100") charCountInd = 16;
            }

            string charCountString = Convert.ToString(textlänge(), 2);
            while (charCountString.Length < charCountInd) charCountString = "0" + charCountString;
            bitfolge = bitfolge + charCountString;

            if (cB_Info.Checked == true) rTB_Info.AppendText("Zeichenanzahl: " + charCountString + "\n");
            showBitfolge = showBitfolge + " " + charCountString;

            if (cB_Info.Checked == true) rTB_Info.AppendText("Bitfolge neu mit Bits zur Zeichenanzahl:\n" + showBitfolge + "\n");



            // Text mit EC-Bytes
            string s = rTB_Text.Text;
            RS_Encode RSE = new RS_Encode("100011101");
            
            int[] datenBytes;
            

            // bitfolge besteht schon aus Modus-Indikator und Textlänge ... jetzt weiter ausbauen
            
            info = info + "\n";
            datenBytes = new int[s.Length];

            bool ok = true;
            
            
            // Modus - Unterscheidung bei der byteaufbereitung
            if (modeInd == "0001") // numeric mode
            {
                
                /*
                    In numeric mode ,data is delimited by 3 digits.
                    For example,"123456" is delimited "123" and "456",and first data is "123",second data is "456".
                    And each data is encoded in   10bit    long binary representation.

                    When length of delimited data is 1 or 2,    4bit    long or    7bit    long are used in each case.
                    For example,"9876" is delimited "987" in 10 bit long and "6" in 4 bit long.
                    Its result is "1111011011 0110"
                */
                string s0 = s;
                while (s0.Length>=3)
                {
                    string dreiText = s0.Substring(0, 3);  // 3 Ziffern als String
                    s0 = s0.Substring(3);
                    int dreiInt=0;
                    try { dreiInt = Convert.ToInt16(dreiText); } // 3 Ziffern als int-Wert
                       catch { ok = false; }
                    string dreiBin = bitsAusIntL(dreiInt, 10);
                    bitfolge = bitfolge + dreiBin;
                    info = info + dreiText + "  " + dreiInt.ToString().PadLeft(3) + "  " + dreiBin + "\n";
                }
                if (s0.Length > 0)
                {
                    int s0Int=0;
                    try { s0Int = Convert.ToInt16(s0); } catch { ok = false; }
                    string s0Bin; 
                    if (s0.Length == 1) s0Bin = bitsAusIntL(s0Int, 4);
                    else s0Bin = bitsAusIntL(s0Int, 7);

                    bitfolge = bitfolge + s0Bin;
                    info = info + s0 + "  " + s0Int.ToString().PadLeft(3) + "  " + s0Bin + "\n";
                }
            }

            if (ok == false) { rtbo(rTB_Info, "MODUS-FEHLER ??? ZEICHENFEHLER !!!\n"); return; }

            if (modeInd == "0010") // alphanumeric mode
            {
                /*
                0,1,2,3,4,5,6,7,8,9, A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z,  , $, %, *, +, -, ., /, :
                0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44
                Next we consider delimited data by 2 numbers. First value increase 45 times and second value is added to it. 
                Result value is encoded in     11bit    long binary representation. 
                When length of delimited data is 1,     6bit     long are used.
                */
                string alphaSortiment = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ $%*+-./:";
                string s0 = s;
                while (s0.Length >= 2)
                {
                    string zweiText = s0.Substring(0, 2);  // 2 ZEICHEN als String
                    s0 = s0.Substring(2);
                    int a = alphaSortiment.IndexOf(zweiText[0]); if (a < 0) { ok = false; s0 = ""; }
                    int b = alphaSortiment.IndexOf(zweiText[1]); if (b < 0) { ok = false; s0 = ""; }
                    int zweiInt = 45 * a + b; // 3 Ziffern als int-Wert
                    string zweiBin = bitsAusIntL(zweiInt, 11);
                    bitfolge = bitfolge + zweiBin;
                    
                    info = info + zweiText + "  " + a.ToString().PadLeft(3) + "  " + b.ToString().PadLeft(3) + "  " +
                        zweiInt.ToString().PadLeft(3) + "  " + zweiBin + "\n";
                }
                if (s0.Length > 0)
                {
                    int a = alphaSortiment.IndexOf(s0[0]); if (a < 0) { ok = false; s0 = ""; }
                    string s0Bin = bitsAusIntL(a, 6); 

                    bitfolge = bitfolge + s0Bin;
                    info = info + s0 + "  " + a.ToString().PadLeft(3) + "  " + s0Bin + "\n";
                }

            }

            if (ok == false) { rtbo(rTB_Info, "MODUS-FEHLER ??? ZEICHENFEHLER !!!\n");  return; }

            if (modeInd == "0100")  // byte - Mode ... normaler Modus
            { 
                for (int i = 0; i < s.Length; i++)
                {
                    char c = s[i];
                    datenBytes[i] = (int)c;
                    string hdB = bitsAusInt(datenBytes[i]);
                    bitfolge = bitfolge + hdB;
                    
                    showBitfolge = showBitfolge + " Z:" + hdB;
                    if (cB_Info.Checked == true) rTB_Info.AppendText(c + "  " + datenBytes[i].ToString().PadLeft(3) + "  " + hdB + "\n");
                    info = info + c + "  " + datenBytes[i].ToString().PadLeft(3) + "  " + hdB + "\n";
                }
            }

            if (cB_Info.Checked == true) rTB_Info.AppendText("Bitfolge neu mit Textbytes:\n" + showBitfolge + "\n");
            // Ende Modus
            // Die Modusbits, Zeichenanzahlbits und Datenbits sind nun in bitfolge am Stück abgelegt

            // Der Terminator kommt hinzu
            bitfolge = bitfolge + "0000";
            showBitfolge = showBitfolge + " T:" + "0000  F:";
            if (cB_Info.Checked == true) rTB_Info.AppendText("Bitfolge neu mit Terminator:\n" + showBitfolge + "\n");
            // und man bringt die bitfolge auf das Byteformat ... aus 8-ter Länge bringen
            while (bitfolge.Length % 8 != 0)
            {
                bitfolge = bitfolge + "0";
                showBitfolge = showBitfolge + "0";
            }

            if (cB_Info.Checked == true) rTB_Info.AppendText("Bitfolge neu mit \"0\"-Füllbits:\n" + showBitfolge + "\n");
            showBitfolge = showBitfolge + " - " ;
            // danach Auffüllen mit 236 und 17 im Wechsel ... bis zur Kapazitätsgrenze
            int db1 = QR_Daten[5, QR_Daten_Position];  // Anzahl der Datenbytes total (Kapazitätsgrenze)
            while (bitfolge.Length / 8 < db1 - 1)
            {
                bitfolge = bitfolge + "1110110000010001";  //   236  und  17
                showBitfolge = showBitfolge + " 236 17";
            }
            if (bitfolge.Length / 8 < db1)
            {
                bitfolge = bitfolge + "11101100";  // 236
                showBitfolge = showBitfolge + " 236";
            }
            if (cB_Info.Checked == true) rTB_Info.AppendText("Bitfolge neu mit Füllbytes:\n" + showBitfolge + "\n");

            if (cB_Info.Checked == true) rTB_Info.AppendText("echte Bitfolge\n" + bitfolge + "\n");


            int maximum = Math.Max(datenBytesProGr1Block, datenBytesProGr2Block);
            maximum = Math.Max(maximum, korrBytesProBlock);

            int[,,,] bytes = new int[2,             // Gruppe 1 / Gruppe 2
                Math.Max(anzBlockGr1,anzBlockGr2),  // je Gruppe 1 bis max. 67 Blöcke
                2,                                  // jeweils Daten / ECC
                maximum];                           // jeweils 1 bis max. 125 Zeichen




            if ((anzBlockGr1 + anzBlockGr2) > 1) // größer als 1 ab Version L6, M4, Q3 und L3 und jeweils höher
            {
                rTB_Info.AppendText("\n\nBitfolge nur mit Datenbits:\n");
                info = info + "\n\nBitfolge nur mit Datenbits:\n";
                datenBytes = new int[bitfolge.Length / 8];
                for (int i = 0; i < bitfolge.Length / 8; i++)
                {
                    datenBytes[i] = Convert.ToInt16(bitfolge.Substring(i * 8, 8), 2);
                    
                }
                info = info + "\n";
                for (int i = 0; i < bitfolge.Length / 8; i++) info = info + datenBytes[i].ToString().PadLeft(4); 
                info = info + "\n";

                kommentarBox.AppendText("\n");
                int posZeiger = 0;
                for (int i = 0; i < anzBlockGr1; i++)
                {
                    string daten = "";
                    string kommentar = "\n 1-" + i.ToString().PadLeft(3)+ " ? ";
                    info = info + "\nGr 1 - Block " + i.ToString() + "    Daten\n";
                    for (int j = 0; j < datenBytesProGr1Block; j++)
                    {
                        if (posZeiger < db1) { bytes[0, i, 0, j] = datenBytes[posZeiger]; posZeiger++; }
                        else { bytes[0, i, 0, j] = 0; kommentar = kommentar + "," + j.ToString(); }
                        string h = bytes[0, i, 0, j].ToString();
                        info = info + h + " ";
                        daten = daten + " " + h;
                    }
                    info = info + "\nGr 1 - Block " + i.ToString() + "    ECC\n";
                    int[] antwort = RSE.RSEncode(daten, korrBytesProBlock, "100011101");
                    for (int j = 0; j < korrBytesProBlock; j++)
                    {
                        bytes[0, i, 1, j] = antwort[korrBytesProBlock-j-1];
                        string h = bytes[0, i, 1, j].ToString();
                        info = info + h + " ";
                    }
                    if (kommentar.Length > 11) kommentarBox.AppendText(kommentar+"\n");
                }


                if (anzBlockGr2>0)
                {
                    for (int i = 0; i < anzBlockGr2; i++)
                    {
                        string daten = "";
                        string kommentar = "\n 2-" + i.ToString() + " ? ";
                        info = info + "\nGr 2 - Block " + i.ToString() + "    Daten\n";
                        for (int j = 0; j < datenBytesProGr2Block; j++)
                        {
                            if (posZeiger < db1) { bytes[1, i, 0, j] = datenBytes[posZeiger]; posZeiger++; }
                            else { bytes[1, i, 0, j] = 0; kommentar = kommentar + "," + j.ToString(); }

                            string h = bytes[1, i, 0, j].ToString();
                            info = info + h + " ";
                            daten = daten + " " + h;
                        }
                        info = info + "\nGr 2 - Block " + i.ToString() + "  ECC\n";
                        int[] antwort = RSE.RSEncode(daten, korrBytesProBlock, "100011101");
                        for (int j = 0; j < korrBytesProBlock; j++)
                        {
                            bytes[1, i, 1, j] = antwort[korrBytesProBlock - j - 1];
                            string h = bytes[1, i, 1, j].ToString();
                            info = info + h + " ";
                        }
                        if (kommentar.Length > 11) kommentarBox.AppendText(kommentar + "\n");
                    }
                }

                // nun sind alle Bytes (Daten und EC) vorhanden
                // neu sortieren:

                info = info + "\n\nDatenbytes:\n";
                bitfolge = "";
                for (int i=0;i< Math.Max(datenBytesProGr1Block, datenBytesProGr2Block); i++)
                {
                    if (i < datenBytesProGr1Block)
                        for (int j = 0; j < anzBlockGr1; j++)
                        {
                            bitfolge = bitfolge + bitsAusInt(bytes[0, j, 0, i]);
                            info = info + bytes[0, j, 0, i].ToString().PadLeft(4);
                        }
                    if (anzBlockGr2 > 0)
                    {
                        if (i < datenBytesProGr2Block)
                            for (int j = 0; j < anzBlockGr2; j++)
                            {
                                bitfolge = bitfolge + bitsAusInt(bytes[1, j, 0, i]);
                                info = info + bytes[1, j, 0, i].ToString().PadLeft(4);
                            }
                    }
                }
                info = info + "\n\nECC-Bytes:\n";

                for (int i = 0; i < korrBytesProBlock; i++)
                {
                    for (int j = 0; j < anzBlockGr1; j++)
                    {
                        bitfolge = bitfolge + bitsAusInt(bytes[0, j, 1, i]);
                        info = info + bytes[0, j, 1, i].ToString().PadLeft(4);
                    }
                    if (anzBlockGr2 > 0)
                        for (int j = 0; j < anzBlockGr2; j++)
                        {
                            bitfolge = bitfolge + bitsAusInt(bytes[1, j, 1, i]);
                            info = info + bytes[1, j, 1, i].ToString().PadLeft(4);
                        }
                }
                info = info + "\n";





            }
            else // es gibt dann nur einen Block (auch mit obigem Teil lösbar, aber ... es gibt hier mehr Rechenergebnis-Anzeigen zur Demonstration
            {
                int korrekturBytesAnzahl = QR_Daten[8,QR_Daten_Position]; // pro Block
                int[] EC_Bytes = new int[korrekturBytesAnzahl];

                info = info + "\n\nBitfolge nur mit Mode, Länge und Textbits:\n";
                datenBytes = new int[bitfolge.Length / 8];
                for (int i=0;i< bitfolge.Length / 8;i++)
                {
                    datenBytes[i] = Convert.ToInt16(bitfolge.Substring(i * 8, 8), 2);
                    info = info + i.ToString().PadLeft(3) + "-" + bitfolge.Substring(i * 8, 8) + " (" + datenBytes[i].ToString().PadLeft(3) + ")   ";
                    if ((i + 1) % 5 == 0) info = info + "\n"; 
                }

                // RS_Encode RSE = new RS_Encode();   ... siehe oben
                string daten = "";
                for (int i = 0; i < datenBytes.Length; i++) daten = daten + " " + datenBytes[i].ToString();

                int[] antwort = RSE.RSEncode(daten, korrekturBytesAnzahl, "100011101");

                // nur zur Kontrolle: -------------------------------------------------------------
                info = info + "\n\nDatenpolynom beginnend bei x^0 ..\n";
                for (int i = 0; i < datenBytes.Length; i++)
                {
                    info = info + datenBytes[i].ToString().PadLeft(3) + "  ";
                    if ((i + 1) % 10 == 0) info = info + "\n";    
                }
                info = info + "\nNachrichtenpolynom beginnend bei x^0 ..\n";
                for (int i = 0; i < RSE.originalNachricht.Length; i++)
                {
                    info = info + RSE.originalNachricht[i].ToString().PadLeft(3) + "  ";
                    if ((i + 1) % 10 == 0) info = info + "\n";   
                }
                info = info + "\nGeneratorpolynom beginnend bei x^0 ..\n";
                for (int i = 0; i < RSE.gen.Length; i++)
                {
                    info = info + RSE.gen[i].ToString().PadLeft(3) + "  ";
                    if ((i + 1) % 10 == 0) info = info + "\n";   
                }
                info = info + "\nAntwortpolynom mit ECC-Daten - beginnend bei x^0 ..\n";
                for (int i = 0; i < antwort.Length; i++)
                {
                    info = info + antwort[i].ToString().PadLeft(3) + "  ";
                    if ((i + 1) % 10 == 0) info = info + "\n";   
                }
                // Ende --------------------------- Kontrollanzeige --------------------------------

                // bitfolge weiter ausbauen
                string endgültigeDaten = "";
                info = info + "\n\nEndgültiger Datensatz:\n";
                int maxi = antwort.Length;
                int zw = 0;
                for (int i = maxi - 1; i >= korrekturBytesAnzahl; i--)
                {
                    endgültigeDaten = endgültigeDaten + "  " + RSE.originalNachricht[i].ToString("##0").PadLeft(3);
                    info = info + RSE.originalNachricht[i].ToString().PadLeft(3) + "  ";
                    zw++; if (zw % 10 == 0) info = info + "\n";    
                }
                endgültigeDaten = endgültigeDaten + "   ";
            
                for (int i = korrekturBytesAnzahl - 1; i >= 0; i--)
                {
                    endgültigeDaten = endgültigeDaten + "  " + antwort[i].ToString("##0").PadLeft(3);
                    info = info + antwort[i].ToString().PadLeft(3) + "  ";
                    zw++; if (zw % 10 == 0) info = info + "\n";    
                    bitfolge = bitfolge + bitsAusInt(antwort[i]); 
                }
                info = info + "\nEndgültiger Datensatz:  " + endgültigeDaten;
            }

            if (cB_Info.Checked == true) rTB_Info.AppendText("\n\nBitfolge am Ende:\n"+bitfolge+"\n");
            // wieviele Felder sind noch frei?
            int wartezeit_ms = 0; 
                // s.u. .... kann evtl. unten noch zu Testzwecken / Verfolgung des Ablaufs verwendet werden
            int zw1 = 0;

            picB_QRC.Image = piCBild;
            Graphics g = Graphics.FromImage(picB_QRC.Image);
            Color F;
            int richtung = -1;
            int ze = kästchenzahl - 1;
            int sp = kästchenzahl - 1;
            zaehlwerk = 0;
            while (sp>0)
            {
                if (richtung == -1)
                {
                    while (ze >= 0)
                    {
                        if (bitArt[sp, ze] == 0)
                        {
                            F = bitFarbe(zw1);
                            fülleBit(g, F, F, sp, ze);
                            zw1++;
                            //Thread.Sleep(wartezeit_ms);
                        }
                        if (bitArt[sp - 1, ze] == 0)
                        {
                            F = bitFarbe(zw1);
                            fülleBit(g, F, F, sp - 1, ze);
                            zw1++;
                            //Thread.Sleep(wartezeit_ms);
                        }
                        ze--;
                    }
                    richtung = 1; ze = 0; 
                }

                else
                { 
                    while (ze < kästchenzahl)
                    {
                        if (bitArt[sp, ze] == 0)
                        {
                            F = bitFarbe(zw1);
                            fülleBit(g, F, F, sp, ze);
                            zw1++;
                            //Thread.Sleep(wartezeit_ms);
                        }
                        if (bitArt[sp-1, ze] == 0)
                        {
                            F = bitFarbe(zw1);
                            fülleBit(g, F, F, sp - 1, ze);
                            zw1++;
                            //Thread.Sleep(wartezeit_ms);
                        }
                        ze++;
                        
                    }
                    richtung = -1; ze = kästchenzahl - 1;
                }
                sp = sp - 2;
                if (sp == 6) sp = 5;
            }
            piCBild = (Bitmap)picB_QRC.Image;
            info = info + "\nDaten/ECC-Kästchenzahl: " + (zw1 - zaehlwerk).ToString();
            info = info + "\nFreie Kästchen am Ende: " + zaehlwerk.ToString();

            feldFarbeOhneMaske = new int[feldFarbe.GetLength(0), feldFarbe.GetLength(1)];
            for (int i = 0; i < feldFarbe.GetLength(0); i++)
                for (int j = 0; j < feldFarbe.GetLength(1); j++)
                    feldFarbeOhneMaske[i, j] = feldFarbe[i, j];

            tB_Penalty.Text = "";
            rTB_Info.AppendText(info);
        }

        private Color bitFarbe(int pos)
        {
            Color F;
            char c = '-';
            if (pos < bitfolge.Length) 
            {
                c = bitfolge[pos];
                if (c == '0') F = weiss; else F = schwarz;
            }
            else { c = '0'; F = uebrigweiss; zaehlwerk++;  rtbo(kommentarBox, pos.ToString() + "  ");  }
            
            return F;
        }
    }
}
